using C1.DataCollection;
using C1.DataCollection.BindingList;
using C1.Win.TrueDBGrid;
using System.Data;
using System.Diagnostics;

namespace TestTrueDbGrid
{
    internal partial class Form1 : Form
    {
        private readonly C1DataCollectionBindingList _dataSource;
        private readonly Random _random = new();

        public Form1()
        {
            InitializeComponent();
            List<Person> persons = new();

            for (int i = 0; i < 10; i++)
            {
                string lastName = RandomString(10);
                persons.Add(new Person()
                {
                    LastName = lastName,
                    Name = RandomString(7),
                    Category = lastName[..3]
                });
            }

            _dataSource = new C1DataCollectionBindingList(persons);
            c1TruedbGrid1.DataSource = _dataSource;
        }
        private void btnAdd_Click(object sender, EventArgs e)
        {
            string lastName = RandomString(10);

            Person person = new() { LastName = lastName, Name = RandomString(7), Category = lastName[..3] };
            _dataSource.Add(person);

            Text = lastName;

            int addedRowIndex = _dataSource?.DataCollection?.IndexOf(person) ?? -1;
            
            //uncomment this, if you want to collapse all previous rows whenever a new row is added
            //c1TruedbGrid1.CollapseGroupRow(-1);

            int offset = 0;

            for (int i = 0; i < addedRowIndex; i++)
            {
                if (c1TruedbGrid1.FocusedSplit.Rows[i].RowType == RowTypeEnum.DataRow)
                {
                    offset++;
                }
            }

            var groupRowIndex = addedRowIndex + offset;
            c1TruedbGrid1.ExpandGroupRow(groupRowIndex);
            c1TruedbGrid1.Row = groupRowIndex + 1;
        }

        private string RandomString(int length)
        {
            const string chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
            return new string(Enumerable.Repeat(chars, length)
                                        .Select(s => s[_random.Next(s.Length)]).ToArray());
        }
    }
}